/**
  Generated Main Source File
    16F18326_Thermopile
 
  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.77
        Device            :  PIC16F18326
        Driver Version    :  2.00
    Sensor : A3D01S-FU-50-60 
 
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#include "mcc_generated_files/mcc.h"
#include <stdio.h>
#include "lcd_lib2.h"
#include "i2c_lib2.h"
#include "i2c-lib.h"

#define A3D01S_Address 0x7A         // ZT[X[uAhX`:0b0111101(0x3D)+0 = 0b01111010 = 0x7A 
#define Ambient_Resister 0x70        // ZT[ȊxWX^[`(0x70:Self Temp.)
#define Object_Resister 0x71        // ZT[IuWFNgxWX^[`(0x71:Object Temp.)

// O[oϐ錾
float Tt,Tp;         // f[^i[pϐ(Tt:, Tp:IuWFNg) 
float THT,THP;      // xZi[pϐ(TET:, TEP:IuWFNg) 
unsigned long data[3];      // ZT[Mf[^i[pϐ

// vg^CsO錾
void A3D01S_T(void);        // ȉx֐
void A3D01S_P(void);        // IuWFNgx֐

// Wo͊֐p჌x֐`
void putch(unsigned char data) {
    lcd_data(data);                 // t\Wo͊֐Ƃ
}

/*
                         Main application
 */
void main(void)
{
    // initialize the device
    SYSTEM_Initialize();

    // When using interrupts, you need to set the Global and Peripheral Interrupt Enable bits
    // Use the following macros to:

    // Enable the Global Interrupts
    INTERRUPT_GlobalInterruptEnable();          // O[o荞݋

    // Enable the Peripheral Interrupts
    INTERRUPT_PeripheralInterruptEnable();      // ӊ荞݋

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();

    // foCX
    lcd_init();                 // LCD    
   
    while (1)
    {
        // Add your application code

        A3D01S_T();             // ȉx֐Ăяo
        A3D01S_P();             // IuWFNgx֐Ăяo     
      
        // LCDo
        lcd_cmd(0x80);              // LCD1s
            printf("T:%2.1f C", THT);       // ȉx\     
        lcd_cmd(0xC0);                  // LCD2s
            printf("P:%2.1f C", THP);       // IuWFNgx\     
            
        __delay_ms(500);           // 0.5 sec               
       
    }
}

// ȉx֐
void A3D01S_T(void) {

    unsigned int i;

// R}hM    
    i2c_start();                        // I2CX^[gRfBVs        
    i2c_send_byte(A3D01S_Address);         // X[uID + 0(ݗv)
    i2c_send_byte(Ambient_Resister);      // ȉxWX^[
    i2c_stop();                         // I2CXgbvRfBVs     
    
// f[^擾    
    i2c_start();                        // I2CX^[gRfBVs        
    i2c_send_byte(A3D01S_Address);         // X[uID + 0(ݗv)
    i2c_send_byte(Ambient_Resister);      // ȉxWX^[
    i2c_repeat_start();                 // I2Cs[gX^[gRfBVs  
    i2c_send_byte(A3D01S_Address + 1);     // X[uID + 1(ǂݍݗv)

    for (i=0; i<3; i++)                 // f[^擾
        data[i] = i2c_read_byte(1);     // f[^MACKԂ

    i2c_stop();                         // I2CXgbvRfBVs     

// f[^    
    Tt = (data[1] << 8) | data[0];      // x12bit(MSB + LSB)   
    THT = Tt / 8 - 20;                  // ȉxTHT[] = Tp / 8 - 20
    
// PEC͖

}

// IuWFNgx֐
void A3D01S_P(void) {

    unsigned int i;

// R}hM    
    i2c_start();                        // I2CX^[gRfBVs        
    i2c_send_byte(A3D01S_Address);         // X[uID + 0(ݗv)
    i2c_send_byte(Object_Resister);     // ObjectxWX^[
    i2c_stop();                         // I2CXgbvRfBVs     
    
// f[^擾    
    i2c_start();                        // I2CX^[gRfBVs        
    i2c_send_byte(A3D01S_Address);         // X[uID + 0(ݗv)
    i2c_send_byte(Object_Resister);     // ObjectxWX^[
    i2c_repeat_start();                 // I2Cs[gX^[gRfBVs  
    i2c_send_byte(A3D01S_Address + 1);     // X[uID + 1(ǂݍݗv)

    for (i=0; i<3; i++)                 // f[^擾
        data[i] = i2c_read_byte(1);     // f[^MACKԂ

    i2c_stop();                         // I2CXgbvRfBVs     

// f[^    
    Tp = (data[1] << 8) | data[0];      // x12bit(MSB + LSB)   
    THP = Tp / 8 - 30;                  // IuWFNgxTHP[] = Tp / 8 - 30
    
// PEC͖

}

/**
 End of File
*/